/**
 * What the kobold did in Varanar.
 */
function VaranarShared() {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    // PUBLIC MEMBERS \\        this.public = "test";
    this.nightTwo = new NightTwoShared();
    this.dayThree = new DayThreeShared();

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Loads this object from a type-stripped version thereof.
     * @param {VaranarShared-stripped} varanarShared A VaranarShared object, stripped of private members and all functions.
     */
    this.load = function (varanarShared) {
        if (!varanarShared) {
            that.load(new VaranarShared());
            return;
        }
        that.nightTwo.load(varanarShared.nightTwo);
        that.dayThree.load(varanarShared.dayThree);
    };
}

