/**
 * What the kobold did during the third day of Varanar.
 */
function DayThreeShared() {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    // PUBLIC MEMBERS \\        this.public = "test";
    this.morning = new MorningThreeShared();
    this.noon = new NoonThreeShared();
    this.afternoon = new AfternoonThreeShared();

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Loads this object from a type-stripped version thereof.
     * @param {Shared-stripped} shared A Shared object, stripped of private members and all functions.
     */
    this.load = function (shared) {
        if (!shared) {
            that.load(new DayThreeShared());
            return;
        }
        that.morning.load(shared.morning);
        that.noon.load(shared.noon);
        that.afternoon.load(shared.afternoon);
    };
}

