/*
 * The Status class keeps track of the kobold's physical and mental health,
 * fatigue and sexual exertion.
 */
function Status() {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    // PUBLIC MEMBERS \\        this.public = "test";
    this.physical = new PhysicalHealth();
    this.mental = new MentalHealth();
    this.stamina = new Stamina();
    this.exertion = new SexualExertion();

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Loads this object from a type-stripped version thereof.
     * @param {Status-stripped} status A Status object, stripped of private members and all functions.
     */
    this.load = function (status) {
        that.physical.load(status.physical);
        that.mental.load(status.mental);
        that.stamina.load(status.stamina);
        that.exertion.load(status.exertion);
    };
}
