/**
 * Controller for a single choice, regardless of whether it's a continue or a set/get.
 * 
 * Capabilities:
 * -set
 * -get
 * -has
 * -unset
 * -continue
 * -continued
 * 
 * @param {string} id The id of the scene.
 * @param {string} key The key of this choice.
 */
function ChoiceController(id, key) {
    ContinueController.call(this, id, key);
    this.set = function (choice) {
        global.kobold.history.setKey(id, key, choice);
    };
    this.get = function () {
        return global.kobold.history.getKey(id, key);
    };
    this.has = function () {
        return global.kobold.history.has(id, key);
    };
}

