/**
 * The CowboyHat class represents a hat that can be worn by the kobold.
 */
function CowboyHat() {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;

    var itemName = "Cowboy Hat";
    var itemDescription = "A large leather hat with a very distinctive shape.";
    var baseValue = 20;
    var offensiveValue = 0;
    var defensiveValue = 0;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    // PUBLIC MEMBERS \\        this.public = "test";

    // ITEM-REQUIRED item-enum for construction purposes.
    this.id = ItemEnum.COWBOY_HAT;
    // ITEM-REQUIRED type-enum for tooltip purposes.
    this.type = ItemTypeEnum.GEAR;
    // GEAR-REQUIRED slot-enum.
    this.slot = SlotEnum.HELMET;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * ITEM-REQUIRED function.
     * Builds and returns the name of this item.
     * @param {boolean} caps Whether or not the name should be capitalized.
     * @returns {string} The name of this item.
     */
    this.name = function (caps) {
        var toReturn = caps ? itemName : itemName.toLowerCase();
        return toReturn;
    };

    /**
     * ITEM-REQUIRED function.
     * Builds and returns the description of this item.
     * @returns {string} The description of this item.
     */
    this.description = function () {
        return itemDescription;
    };

    /**
     * ITEM-REQUIRED function.
     * Calculates and returns the price (= value) of this item.
     * @returns {int} The price of this pair of pants, in coins.
     */
    this.price = function () {
        return baseValue;
    };

    /**
     * ITEM-REQUIRED function.
     * Builds and returns a custom tooltip style for this item.
     * @returns {string} The custom style.
     */
    this.toolTipStyle = function () {
        return "width: 150px;";
    };

    /**
     * GEAR-REQUIRED function.
     * Calculates and returns the offensive value of this piece of gear.
     * @returns {int} The offensive value of this piece of gear.
     */
    this.offence = function () {
        return offensiveValue;
    };

    /**
     * GEAR-REQUIRED function.
     * Calculates and returns the defensive value of this piece of gear.
     * @returns {int} The defensive value of this piece of gear.
     */
    this.defence = function () {
        return defensiveValue;
    };

    /**
     * HELMET-required function.
     * Returns true if the helmet hides the kobold's face, false otherwise.
     * @returns {boolean} True if the helmet hides the kobold's face, false otherwise.
     */
    this.hidesFace = function () {
        return false;
    };

    /**
     * HELMET-required function.
     * Returns true if the helmet can be torn, false otherwise.
     * @returns {boolean} True if the helmet can be torn, false otherwise.
     */
    this.canBeTorn = function () {
        return false;
    };

    /**
     * HELMET-required function.
     * Returns true if the shoes are a mismatch for the kobold's current gender.
     * @returns {boolean} True if the shoes are a mismatch for the kobold's current gender, false otherwise.
     */
    this.wrongGender = function () {
        return false;
    };

    /**
     * ITEM-REQUIRED function.
     * Loads this object from a type-stripped version thereof.
     * @param {CowboyHat-stripped} helmet A CowboyHat object, stripped of private members and all functions.
     */
    this.load = function (helmet) {
        
    };
}
