/**
 * The SpurredBoots class represents a pair of shoes that can be worn by the kobold.
 */
function SpurredBoots() {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;

    var itemName = "Spurred Boots";
    var itemDescription = "A pair of brown leather boots, with a sharpened, pointy, rotating star-shaped metal bit attached to the rear.";
    var baseValue = 30;
    var offensiveValue = 2;
    var defensiveValue = 2;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    // PUBLIC MEMBERS \\        this.public = "test";

    // ITEM-REQUIRED item-enum for construction purposes.
    this.id = ItemEnum.SPURRED_BOOTS;
    // ITEM-REQUIRED type-enum for tooltip purposes.
    this.type = ItemTypeEnum.GEAR;
    // GEAR-REQUIRED slot-enum.
    this.slot = SlotEnum.SHOES;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * ITEM-REQUIRED function.
     * Builds and returns the name of this item.
     * @param {boolean} caps Whether or not the name should be capitalized.
     * @returns {string} The name of this item.
     */
    this.name = function (caps) {
        var toReturn = caps ? itemName : itemName.toLowerCase();
        return toReturn;
    };

    /**
     * ITEM-REQUIRED function.
     * Builds and returns the description of this item.
     * @returns {string} The description of this item.
     */
    this.description = function () {
        return itemDescription;
    };

    /**
     * ITEM-REQUIRED function.
     * Calculates and returns the price (= value) of this item.
     * @returns {int} The price of this pair of pants, in coins.
     */
    this.price = function () {
        return baseValue;
    };

    /**
     * ITEM-REQUIRED function.
     * Builds and returns a custom tooltip style for this item.
     * @returns {string} The custom style.
     */
    this.toolTipStyle = function () {
        return "width: 200px;";
    };

    /**
     * GEAR-REQUIRED function.
     * Calculates and returns the offensive value of this piece of gear.
     * @returns {int} The offensive value of this piece of gear.
     */
    this.offence = function () {
        return offensiveValue;
    };

    /**
     * GEAR-REQUIRED function.
     * Calculates and returns the defensive value of this piece of gear.
     * @returns {int} The defensive value of this piece of gear.
     */
    this.defence = function () {
        return defensiveValue;
    };

    /**
     * SHOES-required function.
     * Returns true if the shoes leave the kobold's sole exposed, false otherwise.
     * @returns {boolean} True if the shoes leave the kobold's sole exposed, false otherwise.
     */
    this.soleExposed = function () {
        return false;
    };

    /**
     * SHOES-required function.
     * Returns true if the shoes leave the kobold's toes exposed, false otherwise.
     * @returns {boolean} True if the shoes leave the kobold's toes exposed, false otherwise.
     */
    this.toesExposed = function () {
        return false;
    };

    /**
     * SHOES-required function.
     * Returns true if the shoes are a mismatch for the kobold's current gender.
     * @returns {boolean} True if the shoes are a mismatch for the kobold's current gender, false otherwise.
     */
    this.wrongGender = function () {
        return false;
    };

    /**
     * ITEM-REQUIRED function.
     * Loads this object from a type-stripped version thereof.
     * @param {SpurredBoots-stripped} shoes A SpurredBoots object, stripped of private members and all functions.
     */
    this.load = function (shoes) {
        
    };
}
