/**
 * Outside section of Enslavement, Noon Two.
 * @param {SlaveNoonTwoController} controller The Enslavement, Noon Two controller.
 */
function SlaveNoonTwoOutsideRefuseGood(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = false;
    var subController = ctrl.preStage;
    var changeController = ctrl.refuseGood;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = ctrl.fragments.stage;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        global.kobold.history.shared.enslavement.noonTwo.goodRefuse = true;
        var injected = ctrl.gag.has();
        var neither = ctrl.potion.get() === SlaveNoonTwoGoodPotionChoice.NEITHER;
        var fucked = global.kobold.history.shared.enslavement.captureFucked;
        var eager = global.kobold.history.shared.enslavement.noonTwo.kissedBallsEager;
        var kissedBalls = global.kobold.history.shared.enslavement.noonTwo.kissedBalls || eager;
        var name = ctrl.misc.name();
        var toReturn = `[p]
                            Darnit.
                            Why couldn't the wolf have brought you to the river instead?!
                            Do you really have to wash up in the [b]middle[/b] of the hamlet, with all these people watching?
                            In a shallow [b]trough[/b] used by beasts of burden to slake their thirst?
                            You ${injected ? `sigh internally` : `let out another sigh`}.
                            You'd rather have some [b]privacy[/b] and the comfort of [b]running[/b] or at least [b]fresh[/b] water,
                            instead of this stale puddle of [b]animal spit[/b].
                        [/p]
                        [p]
                            It may be too late for the two of you to head for the river,
                            but that doesn't mean you're going to [b]wallow[/b] in animal grool for the bandit's amusement.
                            ${fucked ? `${eager ? `You wear Fenrir's dried spunk with pride,
                            and you don't want it washed off.` : `While you're eager to rid yourself of Fenrir's dried spunk,
                            you're not going to degrade yourself to wash it off.`}` : `It would be nice to wash off all the dirt from the chase,
                            but you're not going to degrade yourself for it.`}
                            Besides, it's a watering trough.
                            If you clean yourself in it, where will all the animals drink from?
                            Plus, your captor said the auction was starting soon.
                            You won't be able to dry yourself in time if you [i]take a dip[/i].
                        [/p]
                        [p]
                            Tilting your head upwards, you meet the wolf's determined gaze with a resolute stare of your own.
                            Your nerves steeled, you ${injected ? `firmly shake your head no` : `boldly refuse his request for you to bathe`}.
                            "[color=gblue]We [b]don't[/b] have time for this.
                            [b]Get in the tub.[/b][/color]"
                            Like a young child refusing to take an order from its parents, you hold your ground, stubbornly denying the canine.
                            Fenrir lets out an exasperated groan.
                            "[color=gblue]Listen, I'm not going to force you to wash up.
                            The caravan master's going to be [b]pissed[/b] that you're still covered in ${fucked ? `jizz` : `dirt`}, but so be it.
                            I'll take the flak for you this [b]one[/b] time, just because I like you.
                            [b]Don't[/b] get used to-[/color]"
                            Suddenly, a booming voice interrupts the bandit.
                        [/p]
                        [p]
                            [big][color=brown][b]Fenrir!![/b][/color][/big]
                        [/p]
                        [p]
                            It's the caravan master!
                            He's approaching the two of you rapidly.
                            "[color=brown]What the [b]hell[/b] are you doing, standing around?!
                            I thought I told you to get the slave cleaned?![/color]"
                            The chubby man walks up to the wolf.
                            Despite the lupine being nearly an entire foot taller,
                            the human assumes a crude, threatening posture, as if looking for a fight.
                            You [i]want[/i] to come between the two to explain what happened, yet you fail to find the courage to do so.
                            ${injected ? `Besides, you can't speak through your ${global.kobold.inventory.createItemWithTooltip(new UnderwearGag())}` : ``}
                        [/p]
                        [p]
                            "[color=gblue]Kobold's clean enough to be sold.
                            Now [b]back off[/b].[/color]"
                            Your captor's calm, collected response only serves to anger his [sneak]temporary[/sneak] superior further.
                            "[color=brown]Back off?!
                            I asked [b]one[/b] simple thing of you!
                            But then again, you couldn't even guard the transport in the first place![/color]"
                        [/p]
                        [p]
                            The wolf tries, but fails to come up with an apt response.
                            Sighing discontently, he submissively takes a step backwards.
                            For a moment there, you thought this was going to end in a fight.
                            "[color=brown]That's right.
                            Know your place, [b]mutt[/b].
                            Now quit acting like the [b]animal[/b] you are, and go get dressed.[/color]"
                            After an intense stare-down, Fenrir finally turns around.
                            Audibly grumbling, he begins to make his way back to the wagons, leaving you alone with the human, who harrumphs angrily.
                            "[color=brown]The baron will hear of this.[/color]"
                        [/p]`;
        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (subController.continued()) {
            return;
        }

        registerNextListener();
    };
}
