/**
 * Scavenge section of the bandit encounter.
 * @param {ForestController} controller The forest controller.
 */
function ForestBanditScavenge(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var toContinue = new ForestBanditScavengeContinue(controller);

    var doId = "banditScavengeDoButton";
    var dontId = "banditScavengeDontButton";

    var contentStart = `<div class="text">
                            You wait a few more moments, until the gang has left the area.
                            The dragoness lies motionless on the ground, seemingly completely <span class="italic">out of it</span>.
                            The perfect moment for you to grab whatever the bandits didn't.
                            If there's anything left to take, that is.
                        </div>
                        <div class="text">
                            ${(ctrl.bandit.watch.getScavengeSource() === ForestBanditScavengeSourceEnum.KEEPWATCHING) ? "You step out from behind your cover, and walk into the clearing." : "You step out of the bush, and walk into the clearing."}
                            The cum-coated dragoness doesn't even turn her head to face you.
                            She seems completely catatonic, blankly staring up at the sky.
                            Good, that means she won't object to you scouring about for stuff to steal.
                            Still, you keep an eye on her. 
                            You never know.
                            You remember an old rhyme you heard during one of your trips to Varanar:
                            <span class="italic">Around dragons, watch your wagons.</span>
                        </div>
                        <div class="text">
                            The first thing you check is the tattered remains of the woman's robe.
                            You look through the cloth scraps for pockets, a hidden compartiment or any concealed valuables.
                            Sadly, your search comes up empty.
                            There is nothing but torn textile left, and you doubt a merchant would pay any kind of coin for bits of fabric.
                        </div>
                        <div class="text">
                            You move on to inspecting the dragoness' body.
                            From a distance, of course.
                            You don't want to get your scales sticky.
                            Besides the large amount of spunk covering her body, nothing in particular seems to be sticking out.
                            Whatever riches she had were probably taken by the bandits.
                            A small piece of cut rope lies next to her neck, a remnant of her coin pouch, or so you assume.
                            No sign of the purse itself, though.
                        </div>
                        <div class="text">
                            You sigh audibly.
                            You didn't really <span class="italic">expect</span> to find anything, but you still feel kind of let down.
                            With the main points of interest searched, you begin to scrounge the rest of the clearing, 
                            in hopes of finding at least <span class="italic">something</span> to take home.
                        </div>
                        <div class="text">
                            You comb through the leaves and you brush through a few patches of grass,
                            looking for anything that may have been lost during the struggle.
                            A stray coin, a lost ring, maybe even a necklace.
                            Heck, you'd settle for a gold tooth.
                        </div>
                        <div class="text">
                            Again, you find nothing.
                            Just as you are about to completely abandon your search, 
                            you feel something <span class="italic">other</span> than the usual muddy dirt underneath your foot.
                            Looking down, you find that you are standing on top of the dragoness' thoroughly used and then discarded `;

    var contentEnd = `  </div>
                        <div class="text">
                            At first, you are revolted.
                            While made out of a fine material, the underwear is soaked with spunk and precum, dirty with mud, and filthy 
                            ${(ctrl.bandit.watch.getScavengeSource() === ForestBanditScavengeSourceEnum.KEEPWATCHING) ? "from it being rubbed against the dragoness' sole and" : ""}
                            from being stepped on by you, <span class="italic">just now</span>.
                            Then, you begin to remember the way they looked <span class="italic">before</span> the bandits, particularly 
                            ${(ctrl.bandit.watch.getScavengeSource() === ForestBanditScavengeSourceEnum.INDULGE) ? "your new friend" : "the foot-obsessed one"}, 
                            got their hands on it.
                            They covered the dragoness' loins rather nicely.
                            And they fit her frame <span class="bold">so</span> well.
                        </div>`;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content of this section.
     */
    function buildContent() {
        var content = contentStart;
        var panties = new SilkPanties();
        panties.stain("Cum and Mud");
        content += global.kobold.inventory.createItemWithTooltip(panties) + ".";
        content += contentEnd;
        return content;
    }

    /**
     * Builds and returns the do button.
     */
    function buildDoChoice() {
        var disabled = ctrl.bandit.watch.hasMadeScavengeChoice() ? "disabled" : "";
        var isSelected = ctrl.bandit.watch.getScavengeChoice() == ForestBanditScavengeChoiceEnum.DO;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${doId}" ${disabled}>Put them on</button>`;

        var tooltip = `They <span class="bold">are</span> made out of silk. It'd be a shame to let them go to waste.`;
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 200px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the don't button.
     */
    function buildDontChoice() {
        var disabled = ctrl.bandit.watch.hasMadeScavengeChoice() ? "disabled" : "";
        var isSelected = ctrl.bandit.watch.getScavengeChoice() == ForestBanditScavengeChoiceEnum.DONT;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${dontId}" ${disabled}>Do not</button>`;

        var tooltip = `Gross, you're not going to wear those!`;
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 200px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += buildDoChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildDontChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables both buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + doId), $("#" + dontId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the help button.
     */
    function registerDoListener() {
        $("#" + doId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.bandit.watch.makeScavengeChoice(ForestBanditScavengeChoiceEnum.DO);
            loadNextPart(toContinue);
        });
    }

    /**
     * Adds a listener to the scavenge button.
     */
    function registerDontListener() {
        $("#" + dontId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.bandit.watch.makeScavengeChoice(ForestBanditScavengeChoiceEnum.DONT);
            loadNextPart(toContinue);
        });
    }


    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = "banditScavenge";

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (!ctrl.bandit.watch.hasScavengeSource()) {
            return "";
        }
        ctrl.bandit.watch.scavengeShared();
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += buildChoice();
        part += `</div>`;
        part += toContinue.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (!ctrl.bandit.watch.hasScavengeSource()) {
            return;
        }

        toContinue.registerListeners();

        if (ctrl.bandit.watch.hasMadeScavengeChoice()) {
            return;
        }

        registerDoListener();
        registerDontListener();
    };
}

/**
 * Choices for the scavenge part of the bandit encounter.
 */
var ForestBanditScavengeChoiceEnum = {
    DO: 1,
    DONT: 2
};

/**
 * Source for the scavenge part of the bandit encounter.
 */
var ForestBanditScavengeSourceEnum = {
    MASTURBATE: 1,
    KEEPWATCHING: 2,
    INDULGE: 3
};
