/**
 * Breakin section of the farm scene.
 * @param {BreedingFarmController} controller The breeding farm controller.
 */
function BreedingHouse(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        ctrl.createMinigame();
        ctrl.minigame.preload();
        return ctrl.minigame.build();
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        return "";
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = "breedingBarn";

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (ctrl.arrival.get() !== BreedingFarmArrivalChoice.HOUSE) {
            return "";
        }
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += buildChoice();
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (ctrl.arrival.get() !== BreedingFarmArrivalChoice.HOUSE) {
            return;
        }

        ctrl.minigame.registerListeners();
    };
}

var BreedingBarnChoice = {
    DECLINE: 1,
    NOTBARN: 2,
    EAGER: 3
};
