/**
 * Massage section of Varanar, Afternoon Three.
 * @param {AfternoonThreeParlorController} controller The Varanar, Afternoon Three controller.
 */
function AfternoonThreeParlorBack(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = AfternoonThreeParlorMassageChoice.BACK;
    var reqController = ctrl.massage;
    var subController = ctrl.postMassage;
    var changeController = ctrl.back;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = ctrl.fragments.postMassage;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        global.kobold.history.shared.varanar.dayThree.afternoon.parlorBackMassage = true;
        var startBoy = global.kobold.history.scenes["Introduction"].gender === GenderEnum.MALE;
        var bargainSuccess = global.kobold.history.shared.varanar.dayThree.afternoon.parlorBargainSuccess;
        var free = ctrl.entrance.get() === AfternoonThreeParlorEntranceChoice.DECLINE || ctrl.bargain.get() === AfternoonThreeParlorEntranceChoice.DECLINE;
        var toReturn = `[p]
                            A back massage might be nice.
                            You're always carrying around a bunch of stuff and lifting heavy things and crouching to stay hidden.
                            All of this has lead to a constant, dull pain building up in your lower back,
                            which makes sleeping a little less comfortable than it used to be.
                            If Orange could fix or [i]alleviate[/i] those pains a little, you'd love her forevermore,
                            and you'd undoubtedly come back for a second massage after you've scrounged together enough money.
                        [/p]
                        [p]
                            You don't know enough about massaging to know whether or not a simple rubdown [i]can[/i] fix your ailments,
                            but instead of confirming or denying, the orange-scaled kobold simply gestures towards the nearest massage table,
                            and gives you a small wink, as if wordlessly saying to let her work her magic.
                        [/p]
                        [p]
                            You eagerly clamber ontop of the wooden table, and lay yourself down ontop of it, belly-down.
                            This thing was obviously built for species [b]far[/b] bigger than you are.
                            You scoot upwards, until your head ends up resting atop a comfortable pillow at the far end of the wooden surface.
                            Orange climbs up as well, with a bit more tact, style and grace than you.
                            She [i]is[/i] a professional, after all.
                            Or maybe she's just done this enough to know how to get ontop of the table without looking like an idiot.
                        [/p]
                        [p]
                            After coating her hands in massage oil,
                            your masseuse drops to her knees, and begins the massage by placing her hands on your upper back,
                            where your neck and shoulders meet.
                            Before starting to rub you proper, she takes a moment to feel around with her thumbs,
                            looking for knots and kinks she needs to focus on.
                            Your back has [b]lots[/b] of those.
                            Heck, it's practically one big kink wrapped in a knot.
                        [/p]
                        [p]
                            The masseuse does not understand your half-assed attempt at a joke.
                            Unbeknownst to you, she rolls her eyes, concentrating on giving you a proper massage.
                            And that she does.
                            She presses her soft, slickened hands against your back, and begins to rub around in small, circular motions,
                            pleasantly grinding her palms into your scales, reaching every nook and cranny, almost making you [b]squeal[/b] in pure ecstacy.
                            It feels [b]so[/b] good!
                            It's like all your worries and pain are [b]melting[/b] under her soft and gentle, yet surprisingly firm touch.
                        [/p]
                        [p]
                            And she hasn't gotten to the good parts yet.
                            Her hands slowly drift lower and lower, getting to the root of the problem,
                            straightening your back with a firm push before starting to [b]squeeze[/b] your flesh, kneading it in an almost [i]sexual[/i] manner.
                            You let out a relaxed sigh.
                            It feels as though a huge weight is being lifted off your back.
                            For a moment, the treatment stops, but after applying a bit more oil, it suddenly continues,
                            sending another jolt of near-orgasmic goodness coursing down your spine.
                        [/p]
                        [p]
                            If you'd known getting a massage felt [b]this[/b] incredible, you'd have
                            ${bargainSuccess || free ? `gladly paid full price` : `coughed up forty coins a lot quicker`}.
                            The sensation of relief only grows as the massage continues, your entire backside receiving the same treatment,
                            from right above your butt to your very shoulders.
                            You closer your eyes, and slowly drift away in pleasure.
                        [/p]
                        [p]
                            "[color=orange]Time's up![/color]" comes Orange's heavenly voice, far earlier than you would have expected it.
                            You must have dozed off for a few minutes, or maybe time really does go by faster when you're having fun.
                            Either way, your back hasn't felt this good since you were a little ${startBoy ? `boy` : `girl`}.
                            It really does feel like you were born anew.
                        [/p]
                        [p]
                            You run one of your own hands over your oily back.
                            With your muscles loosened, your frame feels more supple, yet also more [b]firm[/b],
                            like you can take a beating and keep on slugging.
                            Like your loosened scales will dampen blows.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}
