/**
 * Massage section of Varanar, Afternoon Three.
 * @param {AfternoonThreeParlorController} controller The Varanar, Afternoon Three controller.
 */
function AfternoonThreeParlorFeet(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = AfternoonThreeParlorMassageChoice.FEET;
    var reqController = ctrl.massage;
    var subController = ctrl.postMassage;
    var changeController = ctrl.feet;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = ctrl.fragments.postMassage;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        global.kobold.history.shared.varanar.dayThree.afternoon.parlorFootMassage = true;
        var startBoy = global.kobold.history.scenes["Introduction"].gender === GenderEnum.MALE;
        var bargainSuccess = global.kobold.history.shared.varanar.dayThree.afternoon.parlorBargainSuccess;
        var free = ctrl.entrance.get() === AfternoonThreeParlorEntranceChoice.DECLINE || ctrl.bargain.get() === AfternoonThreeParlorEntranceChoice.DECLINE;
        var toReturn = `[p]
                            A foot massage is what you want.
                            You've spent your entire life walking around on your bare feet, not to mention climbing stuff.
                            All of this has lead to a constant, dull pain building up in your ankles,
                            which makes running and sprinting a little more [i]intensive[/i] than it used to be.
                            If Orange could fix or [i]alleviate[/i] those pains a little, you'd love her forevermore,
                            and you'd undoubtedly come back for a second massage after you've scrounged together enough money.
                        [/p]
                        [p]
                            You don't know enough about massaging to know whether or not a simple rubdown [i]can[/i] fix your ailments,
                            but instead of confirming or denying, the orange-scaled kobold simply gestures towards the nearest massage table,
                            and gives you a small wink, as if wordlessly saying to let her work her magic.
                        [/p]
                        [p]
                            You eagerly clamber ontop of the wooden table, and lay yourself down ontop of it, belly-down,
                            your feet sticking out from the edge of the table.
                            This thing was obviously built for species [b]far[/b] bigger than you are.
                            You reach upwards, grabbing the present pillow and tugging it towards you so you can comfortably rest your head atop of it.
                        [/p]
                        [p]
                            After coating her hands in massage oil,
                            your masseuse walks over to your feet,
                            and begins the massage by rubbing your soles up and down a little,
                            slathering them in clear, lubricating liquid.
                            Pleasant, but not overly so.
                            Then again, the real massage hasn't even begun.
                        [/p]
                        [p]
                            Speak of the devil, Orange presses both of her thumbs into the sole of your right foot,
                            rubbing them around in circles, pleasantly [b]digging[/b] into your flesh.
                            It feels [b]divine[/b]!
                            Like all the stress and fatigue built up from [b]years[/b] of walking and running is simply [b]melting[/b] away.
                            And the kobold is only getting started.
                        [/p]
                        [p]
                            Grabbing your foot by the ankle, one hand on either side,
                            the masseuse begins to twist it by rubbing up and down in opposite directions.
                            You let out an almost [i]sexual[/i] moan, sheer bliss flooding your mind.
                            Absolutely [b]amazing[/b]!
                        [/p]
                        [p]
                            Your heel is next.
                            She firmly presses her slickened palm against it,
                            rubbing it from side to side for a moment,
                            before stroking alongside the length of your foot,
                            her palm [b]burying[/b] into your scales as it travels all the way to the base of your clawed toes.
                            It feels [b]so[/b] good!
                        [/p]
                        [p]
                            Orange proceeds to grinds her fist into your sole,
                            loosening your muscles, rejuvinating your scales and sending spikes of sheer pleasure coursing up your spine.
                            Each of your toes gets squeezed, tugged, pulled, rubbed, cracked and stretched,
                            the top of your foot gets some care and attention,
                            and the masseuse even thinks to reach in between your toes to complete her work.
                        [/p]
                        [p]
                            Your face sinks deeper into the pillow you're laying on, as Orange moves on to service your [i]other[/i] foot.
                            If you'd known getting a massage felt [b]this[/b] incredible, you'd have
                            ${bargainSuccess || free ? `gladly paid full price` : `coughed up forty coins a lot quicker`}.
                            Soothed by the near-orgasmic goodness coursing down your spine, you close your eyes, and slowly drift away in pleasure.
                        [/p]
                        [p]
                            "[color=orange]Time's up![/color]" comes Orange's heavenly voice, far earlier than you would have expected it.
                            You must have dozed off for a few minutes, or maybe time really does go by faster when you're having fun.
                            Either way, your feet, and particularly your soles haven't felt this good since you were a little ${startBoy ? `boy` : `girl`}.
                            It really does feel like you were born anew.
                        [/p]
                        [p]
                            You flex and curl your toes.
                            With your muscles loosened, and your flesh made more supple, your feel a lot more confident in your ability to run and jump.
                            Plus your softened soles might make you a teensy bit stealthier.
                            The massage has definitely made you more [i]loose[/i], flexible and agile, or at least your feet are.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}
