/**
 * Ruby section of Varanar, Afternoon Three.
 * @param {AfternoonThreeRubyController} controller The Varanar, Afternoon Three controller.
 */
function AfternoonThreeRubyApproachHandOver(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = AfternoonThreeRubyApproachChoice.HAND;
    var reqController = ctrl.screamApproach;
    var changeController = ctrl.approachHandOver;

    var nextSceneReady = ctrl.nextSceneReady;
    var nextSceneName = ctrl.nextSceneName;
    var nextFolderName = ctrl.nextFolderName;

    var continueId = arguments.callee.name + "ButtonOne";

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        global.kobold.history.shared.varanar.dayThree.afternoon.rubyLocket = true;
        global.kobold.history.shared.varanar.dayThree.afternoon.rubyReturned = true;
        var name = ctrl.misc.name();
        var saphiraSaved = global.kobold.history.shared.dragonessPrincess.relation === DragonessPrincessEnum.SAVED;
        var t1 = global.kobold.history.shared.varanar.dayThree.afternoon.rubyt1;
        var t2 = global.kobold.history.shared.varanar.dayThree.afternoon.rubyt2;
        var t3 = global.kobold.history.shared.varanar.dayThree.afternoon.rubyt3;
        var toReturn = ``;

        if (t1) {
            toReturn += `
                        [p]
                            You find it hard to [b]face[/b] the dragoness' glaring gaze.
                            Like you can feel her staring into your very soul.
                            You find yourself averting your eyes a lot, fidgeting about out of sheer nervousness.
                            "[color=cyan]Well, what're you waiting for?[/color]" the lady speaks, in a bossy, commanding tone.
                            "[color=cyan]I gave you an [b]order[/b], you [b]wretch[/b]![/color]"
                        [/p]
                        [p]
                            You meekly explain to her that you, in fact, have already found the locket.
                            You reach into your coin pouch, and produce the trinket.
                            The thief gave it to you and you thought you would return it, because-
                        [/p]
                        [p]
                            Before you can finish your explanation, 
                            the dragoness rudely [b]snatches[/b] the locket from your hand, cutting you off mid-speech!
                            Then, she finishes your sentence for you:
                            "[color=cyan]Because a [b]filthy kobold[/b] like you knows better than to [b]steal[/b] from their superiors!
                            I'm glad you had the [b]common sense[/b] not to run off like your [i]friend[/i] did.
                            Now away with you![/color]"
                        [/p]
                        [p]
                            Before you can explain that the thief was [b]not[/b] your friend,
                            the dragoness dismissively raises her head, turns her back to you, and rudely walks away from your conversation,
                            her gait denoting a resurgence of confidence.
                            You are left looking like quite the fool, standing alone in the midst of a busy street,
                            having handed a valuable possession to a woman that didn't even thank you for your efforts.
                        [/p]
                        [p]
                            Well then.
                            So much for thinking she was a decent person.
                            What a [b]bitch[/b].
                            Her reaction to your [i]heroic intervention[/i] has soured your mood quite a bit.
                            You don't think you want to spend any more time in the kobold distrct, not after an encounter like [i]that[/i].
                            You turn around, and walk the opposite direction, back the way you came.
                        [/p]
                        [p]
                            Through the various overhead obstructions and light-blocking fabrics,
                            you notice the sky is slowly turning dark, and the sun is starting to set.
                            The afternoon is turning into an early winter night.
                            Leaving the kobold district behind you, you head for the mercantile quarter,
                            hoping to find somewhere warm to spend the night,
                            or at least someone who'll treat you with a bit more [b]dignity[/b] and [b]respect[/b] than the woman you tried to help.
                        [/p]`;
        } else if (t2) {
            toReturn += `
                        [p]
                            The dragoness has a haughty look on her face,
                            like she's on top of the world, and no one can tell her otherwise.
                            But she's not in her castle, where she can reign over servants while acting all high and mighty.
                            She's in the midst of the kobold district.
                            [b]Your[/b] kind rules here, [b]not[/b] hers.
                            Still, you remain as nice as you possibly can, giving the lady a small, forced smile.
                        [/p]
                        [p]
                            Your apparent kindness seems to take the wind off her sails a tad, her dignified face relaxing slightly.
                            "[color=cyan]Hmph.
                            Someone in this [b]dump[/b] of a neighbourhood with some manners, for a change.
                            Lead me to my locket, knave.[/color]"
                            Without breaking your smile, you explain to her that that won't be necessary.
                            You had a bit of a [i]bump[/i] with the thief not too far from here, and you managed to get him to [b]relinquish[/b] the locket.
                        [/p]
                        [p]
                            You [b]embellish[/b] the story a little,
                            to make yourself sound a bit more [i]brave[/i] and [i]proactive[/i],
                            but that's pretty much what happened.
                            You reach into your coin pouch, and produce the trinket.
                            As soon as the locket comes to view, the dragoness' eyes light up.
                            "[color=cyan]Yes, excellent!
                            Now hand it over.[/color]"
                            She holds her hand out for you, palm open.
                        [/p]
                        [p]
                            You gracefully place the valuable object in her grasp.
                            She instantly begins to fidget with it, rolling it around and opening it,
                            thoroughly inspecting the piece of jewelry, inside and outside, looking for any marks or scratches.
                            "[color=cyan]Hmph. Good... Good.[/color]"
                            Her anger has faded entirely by now, a small, pleased smirk forming on her face.
                        [/p]
                        [p]
                            The dragoness puts the locket back around her neck, where it belongs.
                            Having calmed down, she addresses you once more.
                            "[color=cyan]Perhaps not [b]all[/b] of you kobolds are just [b]thieves[/b].
                            You are a credit to your race.[/color]"
                            Still arrogant and snobbish, but at least she's regained her manners.
                            If she tones her [i]bitchiness[/i] down a few more levels, you might start to [i]like[/i] her.
                        [/p]
                        [p]
                            "[color=cyan]Here's a little something for your trouble.[/color]" the woman quickly adds,
                            pressing a few coins into your hand.
                            "[color=cyan]Spend it on some food.
                            You look fit to collapse!
                            So tiny and [b]thin[/b].[/color]"
                            You have half a mind to ask her whether you should stuff your face until you're as [b]fat[/b] as she is,
                            but before you even get a chance to bite your tongue, 
                            the dragoness dismissively raises her head, turns her back to you, and rudely walks away from your conversation,
                            her gait denoting a resurgence of confidence.
                        [/p]
                        [p]
                            You look down at the gold she handed you.
                            It's not a lot, and you honestly feel somewhat [b]insulted[/b] by her reaction, but hey.
                            Money's money.
                            You use the coins to fill up the void that the loss of the pendant created in your coin pouch.
                            Your good deed done, you turn around, and walk the opposite direction, back the way you came.
                        [/p]
                        [p]
                            Through the various overhead obstructions and light-blocking fabrics,
                            you notice the sky is slowly turning dark, and the sun is starting to set.
                            The afternoon is turning into an early winter night.
                            You leave the kobold district, and head for the mercantile quarter,
                            hoping to find somewhere warm to spend the night,
                            or at least someone who'll be a bit more [b]grateful[/b] when you help them out.
                        [/p]`;
        } else {
            global.kobold.history.shared.varanar.dayThree.afternoon.rubyKnowsMoeName = true;
            global.kobold.history.shared.varanar.dayThree.afternoon.rubyName = true;
            toReturn += `
                        [p]
                            It's almost surprising how quickly her anger fades when your eyes meet hers.
                            She oggles you up and down, taking in your pleasing presence.
                            She looks confused, almost as though she was expecting you to be some [b]ruffian[/b],
                            instead of the fine-looking kobold that you are.
                            She seems a little [i]naive[/i] when it comes to kobolds, but you're not going to say that to her face.
                        [/p]
                        [p]
                            "[color=cyan]Nevermind all that yelling.[/color]" she corrects herself, without uttering an outright apology.
                            "[color=cyan]I'm just a bit [i]tense[/i].
                            That locket is a [b]very[/b] important item to me, and I'd like it back as soon as possible.[/color]"
                            Well, since she's being [b]nice[/b], for a change.
                            You reach into your coin pouch, and produce the trinket,
                            explaining to the lady how you met with the [b]cowardly[/b] thief that [b]assaulted[/b] her,
                            how he handed the item to you to get rid of it, but you of course knew to return it to its rightful owner.
                        [/p]
                        [p]
                            You manage to make yourself sound downright [b]heroic[/b] without even needing to [i]lie[/i].
                            Her eyes light up in delight and relief as she sees the locket.
                            The dragoness leans down to accept it from you, her initial air of superiority melting before your very eyes!
                            "[color=cyan]Thank you![/color]" she exclaims in a giddy, excited, yet grateful manner,
                            blushing ever so slightly as she straightens her back once more.
                        [/p]
                        [p]
                            The woman inspects her pendant inside and out.
                            You can tell that she's oh-so glad to get it back, in one piece nonetheless.
                            You look up at her with a smile on your face, and tell her that you were happy to be of assistance.
                            The dragoness lets out a satisfied sigh.
                            "[color=cyan]I'm sorry for the way I acted earlier.
                            I can't say I've [b]ever[/b] had any [i]good[/i] experiences with your kind.
                            Not until now, anyway.
                            What is your name, my [i]hero[/i]?[/color]"
                        [/p]
                        [p]
                            Your turn to get excited.
                            She called you a [b]hero[/b]!
                            That's like a knight, but [b]better[/b]!
                            Elated, you tell the chubby dragoness your name.
                            "[color=cyan]${name}? That's an...[i]uhh[/i]...very [b]koboldic[/b] name, for sure.
                            I am [b]Ruby[/b], princess of the United Dragon Empire, and I can not understate my gratitude.[/color]"
                        [/p]
                        ${saphiraSaved ? `
                        [p]
                            [b]Another[/b] princess?
                            You tell Ruby that you helped a dragoness named Saphira back in the forest.
                            Does that name ring any bell?
                            "[color=cyan]My sister?
                            What was [i]she[/i] doing in the forest?
                            Is she okay?[/color]"
                        [/p]
                        [p]
                            Well, the last time you saw her, she was riding a horse into town, flanked by over a dozen heavily armed knights.
                            "[color=cyan]That sounds like Saphira alright.
                            She was always the most [i]boyish[/i] one.
                            Next time you see her, tell her to move back into the mansion instead of staying at the court all the time, okay?
                            It's getting kind of [i]lonely[/i] without her.[/color]"
                            You say that you'll tell her when you see her, but you don't really know [i]when[/i] or [i]if[/i] you ever will.
                            An understanding nod is all you get in return.
                        [/p]` : ``}
                        [p]
                            The dragoness looks around, the improper surroundings visibly souring her mood.
                            "[color=cyan]Thank you once more, but I should probably [i]get going[/i].
                            I'd hate to be seen in a place like [b]this[/b], talking to people like...[/color]"
                            She interrupts herself mid-speech, as to not [b]insult[/b] you.
                            "[color=cyan]No offence.
                            I'm sure you understand.[/color]"
                            You give her a small nod.
                        [/p]
                        [p]
                            "[color=cyan]Oh right. Before I forget: here's a little something, for your trouble.[/color]"
                            Ruby hands you a moderately heavy bag, clearly filled with gold.
                            Your eyes go wide.
                            There must be at least [b]a hundred[/b] coins in there.
                            You stammer out something about not needing any compensation, how it was [b]your pleasure[/b] to help,
                            but you both know you're not going to say [b]no[/b] to such a [b]generous[/b] compensation.
                        [/p]
                        [p]
                            "[color=cyan]It's but spare change to me.
                            Take it.
                            I'm sure you can find a [b]good use[/b] for some coin.
                            Just don't hand it out to other kobolds, okay?[/color]"
                            The dragoness lets out a small, dignified, dainty giggle.
                            "[color=cyan][b]They[/b] didn't come to my rescue.
                            [b]You[/b] did.[/color]"
                        [/p]
                        [p]
                            "[color=cyan]Tahtah, for now.
                            I'm sure we'll meet again.[/color]"
                            That said, the dragoness dismissively raises her head,
                            waves a teensy goodbye to you, turns her back, and walks away,
                            her elegant gait denoting a resurgence of confidence.
                            You can't help but stare at her curvy frame as she disappears into the distance,
                            your heart swelling with a mixture of pride and [i]admiration[/i].
                        [/p]
                        [p]
                            You made a new friend, and a pretty hefty penny.
                            You fill your own coin pouch with the contents of the bag you were handed.
                            With everyone around having seen you accept this [i]gift[/i],
                            you don't think it's a very wise idea to remain in the kobold district for much longer.
                            Your good deed done, you turn around, and walk the opposite direction, back the way you came.
                        [/p]
                        [p]
                            Through the various overhead obstructions and light-blocking fabrics,
                            you notice the sky is slowly turning dark, and the sun is starting to set.
                            The afternoon is turning into an early winter night.
                            You leave the kobold district, and head for the mercantile quarter,
                            hoping to find somewhere warm to spend the night,
                            or at least someone else who you can become friends with.
                        [/p]`;
        }

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the continue button.
     */
    function buildChoice() {
        var disabled = ctrl.continued();
        var choice = `<div class="choicecontainer">`;
        choice += `<button class="button bigbutton continuebutton" id="${continueId}" ${disabled ? "disabled" : ""}>`;
        choice += `Continue &gt;&gt`;
        choice += `</button>`;
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next scene.
     * @param {string} sceneName Name of the scene to load.
     * @param {string} folder Folder of the scene to load.
     */
    function loadNextPart(sceneName, folder) {
        global.ui.fadeOutContent(function () {
            global.sceneEnd();
            global.sceneLoader.loadScene(sceneName, folder);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerContinueListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.continue();
            loadNextPart(nextSceneName, nextFolderName);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        if (!nextSceneReady) {
            part += `<span class="todo">There is no content beyond this point.</span>`;
        }
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        if (ctrl.continued()) {
            return;
        }

        if (nextSceneReady) {
            registerContinueListener();
        }
    };
}
