/**
 * Arrival section of Varanar, Morning Three.
 * @param {MorningThreeController} controller The Morning Three controller.
 */
function MorningThreeEggs(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.knights;
    var subController = ctrl.eggs;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";
    var thirdId = arguments.callee.name + "ButtonThree";

    var firstNext = new MorningThreeDeclineEggs(ctrl);
    var secondNext = new MorningThreeThrowOne(ctrl);
    var thirdNext = new MorningThreeThrowBoth(ctrl);

    var firstChoice = MorningThreeEggsChoice.DECLINE;
    var secondChoice = MorningThreeEggsChoice.ONE;
    var thirdChoice = MorningThreeEggsChoice.BOTH;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var health = ctrl.misc.health();
        var dick = ctrl.misc.dick();
        var She = dick ? `She` : `He`;
        var he = She.toLowerCase();
        var Her = dick ? `Her` : `His`;
        var his = Her.toLowerCase();
        var toReturn = `[p]
                            Arriving finally at the plaza, you notice a commotion at the stage you used as a resting spot last night.
                            A crowd consisting of all walks of life has formed in front of it.
                            There's a few noble-looking dragons, a lot of humans, pigs, dogs, foxes, wolves, cats, a couple of robed birds,
                            orcs taking a break from their manual labor jobs, an entire dwarven family, a bunch of kobolds and even an elf.
                            And that's just the ones you can see on the outskirts of the mob.
                        [/p]
                        [p]
                            Circling around, you see what the entire ordeal is all about.
                            A pillory has been erected on top of the stage.
                            Confined within the stockade is an avian, some kind of hawk, or [i]maybe[/i] a falcon.
                            You aren't sure which.
                            The cheering and insult-hurling crowd is throwing a myriad of rotten fruits and vegetables at the feathery criminal's beaked face.
                            Guards are standing by to make sure nobody [i]helps[/i] the offender.
                            Or maybe they're just there to prevent a [i]riot[/i].
                        [/p]
                        [p]
                            You don't know how to feel about this display.
                            This must be [i]awful[/i] for the bird.
                            You don't know [i]what[/i] he did, and whether or not he even [i]did[/i] what they [i]think[/i] he did.
                            He looks like an okay guy to you, but looks can be deceiving.
                            Maybe he [b]killed someone[/b] or burned down an orphanage or stole from the church or something.
                            Maybe he [b]does[/b] deserve this.
                        [/p]
                        [p]
                            You seem to have caught the attention of one of the kobolds in the crowd.
                            ${She} enthusiastically waves you over.
                            While wary of someone you've never seen before in the middle of a crowd suddenly [i]taking interest[/i] in you,
                            curiosity eventually trumps your initial suspicion.
                            After a bit of dawdling, you approach the cyan-colored kobold.
                        [/p]
                        [p]
                            Standing at about the same height as you, maybe just a [i]little bit[/i] smaller,
                            the kobold that beckoned you over is a rather skinny-looking thing with a big smile across ${his} face.
                            A resident of Varanar, 
                            or so you deduce by the myriad of tiny bruises and scabbed-over cut-wounds${health < 70 ? `, not unlike your own,` : ``}
                            lining ${his} scantily-clad upper body.
                            Still, despite ${his} minor wounds, ${he}'s pretty ${dick ? `cute` : `handsome`}.
                        [/p]
                        [p]
                            You ask the kobold what's going on.
                            What did the bird do to deserve this?
                            ${She} simply shrugs in response.
                            "[color=cyan]Who cares? It's not a kobold. Lighten up. Have some fun![/color]"
                            Before you can refuse, ${he} shoves a pair of smelly ${global.kobold.inventory.createItemWithTooltip(new RottenEgg())}s into your hands.
                            Confused, you look at the spoilt foodstuffs for a few moments, before casting a quizzical gaze your new friend's way.
                            "[color=cyan]Well? What are you waiting for? Throw![/color]"
                        [/p]`;
        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Decline</button>`;

        var tooltip = global.parser.parse(`These eggs [b]stink[/b]. You don't want to throw them.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 180px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>Throw one</button>`;

        var tooltip = global.parser.parse(`Hurl an egg to please the kobold.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 160px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildThirdChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === thirdChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${thirdId}" ${disabled}>Throw both</button>`;

        var tooltip = global.parser.parse(`[b]Free[/b] tossing material? Hurl away!`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 160px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildThirdChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId), $("#" + thirdId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerThirdListener() {
        $("#" + thirdId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(thirdChoice);
            loadNextPart(thirdNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        global.ui.applyTheme("varanar_generic");
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        part += thirdNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();
        thirdNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
        registerThirdListener();
    };
}

var MorningThreeEggsChoice = {
    DECLINE: 1,
    ONE: 2,
    BOTH: 3
};
