/**
 * Proposition section of Varanar, Morning Three.
 * @param {MorningThreeController} controller The Morning Three controller.
 */
function MorningThreeProposition(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = false;
    var subController = ctrl.proposition;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";

    var firstNext = new MorningThreeDeclineSex(ctrl);
    var secondNext = new MorningThreePropositionAgree(ctrl);

    var firstChoice = MorningThreePropositionChoice.DECLINE;
    var secondChoice = MorningThreePropositionChoice.AGREE;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var dick = ctrl.misc.dick();
        var She = dick ? `She` : `He`;
        var he = She.toLowerCase();
        var Her = dick ? `Her` : `His`;
        var his = Her.toLowerCase();
        var Him = dick ? `Her` : `Him`;
        var her = Him.toLowerCase();
        var toReturn = ``;
        if (ctrl.eggs.get() === MorningThreeEggsChoice.ONE) {
            toReturn += `[p]
                            You [i]could[/i] use some cheering up after such a hellish night,
                            and you don't want to look [i]weird[/i] in front of your new friend.
                            Plus it'll be nice to get some [i]retribution[/i] on a non-kobold.
                            After all, knights are supposed to [b]punish[/b] evildoers,
                            and the bird on stage must have done [i]something[/i] to earn his place in the spotlight.
                            With an abundance of reasons to throw, and none to hold back, you decide to let loose and pelt away.
                        [/p]
                        [p]
                            With a small grunt, you chuck your first egg at the trapped avian.
                            The rotten would-be-breakfast soars through the air with a slight curve, before hitting the bird squarely in the face!
                            It cracks open, the disgusting goop contained within splattering all over the man's feathery face, most of the stuff flowing down along his beak.
                            Some of it manages to make its way into his mouth.
                            He gags, sputters and spits.
                            The cyan kobold burst out into laughter, and you join in.
                            "[color=cyan]Rotten like your wife's clutches![/color]"
                            ${She} turns to you.
                            "[color=cyan]Hit'em with the other one![/color]"
                        [/p]
                        [p]
                            You decline.
                            The man you're throwing at is [i]helpless[/i].
                            Bullying him may be fun, but you know first-hand that being on the receiving end is everything but.
                            Doing this, throwing these eggs, makes you no better than the humans and their ilk.
                            And while you [i]did[/i] let yourself go [i]a little[/i], you refuse to stoop yourself down to their level any further.
                        [/p]
                        [p]
                            You drop the rotten egg to the ground, and turn to face your new friend.
                            ${She} seems to respect your decision, an impressed look on ${his} face.
                            In order to lighten the mood a bit, you mention that throwing the first egg [b]was[/b] a lot more fun than you thought it'd be.
                            A small smile forms on ${his} face.
                            You decide to keep up the smalltalk.
                        [/p]
                        [p]
                            You mention you had a really nice time looking at the stars yesterday night,
                            but your visit to Varanar has been kind of going downhill ever since then.
                            Until you met ${her}, that is!
                            The cyan kobold smirks.
                            ${She} reaches out, grabbing your hand, tugging you towards a nearby alley.
                            "[color=cyan]Wanna see some stars? I can help you with that.[/color]"
                            ${She} winks suggestively.
                        [/p]
                        ${global.ui.condSucc(`Charisma greater than 5`)}
                        [p]
                            ${Her} expression, ${his} gentle touch, the innuendo, the wordplay and the privacy ${he}'s seeking,
                            all make ${his} intentions painfully obvious.
                        [/p]`;
        } else {
            toReturn += `[p]
                            You [i]could[/i] use some cheering up after such a hellish night,
                            and you don't want to look [i]weird[/i] in front of your new friend.
                            Plus it'll be nice to get some [i]retribution[/i] on a non-kobold.
                            After all, knights are supposed to [b]punish[/b] evildoers,
                            and the bird on stage must have done [i]something[/i] to earn his place in the spotlight.
                            With an abundance of reasons to throw, and none to hold back, you decide to let loose and pelt away.
                        [/p]
                        [p]
                            With a small grunt, you chuck your first egg at the trapped avian.
                            The rotten would-be-breakfast soars through the air with a slight curve, before hitting the bird squarely in the face!
                            It cracks open, the disgusting goop contained within splattering all over the man's feathery face, most of the stuff flowing down along his beak.
                            Some of it manages to make its way into his mouth.
                            He gags, sputters and spits.
                            The cyan kobold burst out into laughter, and you join in.
                            "[color=cyan]Rotten like your wife's clutches![/color]"
                            ${She} turns to you.
                            "[color=cyan]Hit'em with the other one![/color]"
                        [/p]
                        [p]
                            You don't comply right away.
                            Instead, you hold on to the second egg for a few moments,
                            putting all your [b]fear[/b] and [b]anger[/b] and [b]frustration[/b] into it,
                            as if enchanting it with every [b]semblance[/b] of your misfortune you've [b]ever[/b] had to deal with,
                            all the while [i]aiming[/i] your shot to make sure it'll hit its mark.
                            Only after pouring your very heart and soul into the impending throw, with a surge of great fury and determination, do you let loose.
                        [/p]
                        [p]
                            Like the last, the rotten egg flies gracefully through the air towards its avian target.
                            It seems you may have spent just a little bit [i]too[/i] long aiming, however.
                            Unlike your nigh-perfect first pitch, the second projectile misses the bird's face completely,
                            instead hitting the pillory's confining wood.
                            Oh well, at least some of the rancid splatter still made it to the side of his face.
                        [/p]
                        [p]
                            That second throw made you feel a [b]lot[/b] better.
                            It's as though a weight has been lifted off of your shoulders.
                            You turn towards your new friend, and the two of you wordlessly exchange sadistic grins.
                            You thank ${her} for the eggs.
                            You've rarely had this much fun.
                        [/p]
                        [p]
                            You mention you had a really nice time looking at the stars yesterday night,
                            but your visit to Varanar has been kind of going downhill ever since then.
                            Until you met ${her}, that is!
                            The cyan kobold smirks.
                            ${She} reaches out, grabbing your hand, tugging you towards a nearby alley.
                            "[color=cyan]Wanna see some stars? I can help you with that.[/color]"
                            ${She} winks suggestively.
                        [/p]
                        ${global.ui.condSucc(`Charisma greater than 5`)}
                        [p]
                            ${Her} expression, ${his} gentle touch, the innuendo, the wordplay and the privacy ${he}'s seeking,
                            all make ${his} intentions painfully obvious.
                        [/p]`;
        }
        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Decline</button>`;

        var tooltip = global.parser.parse(`After last night, you're not in the mood.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 160px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var exertionCheck = ctrl.misc.exertion() >= 60;
        var disabled = subController.has() || exertionCheck ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>Agree</button>`;

        var tooltipStart = ctrl.misc.dick() ? `She [i]is[/i] pretty cute.` : `He [i]is[/i] kind of handsome.`;
        var tooltip = global.parser.parse(`${tooltipStart} Accept the kobold's offer.`);

        if (exertionCheck) {
            tooltip = global.parser.parse(`You are too sexually exerted to take up the kobold's offer.`);
        }

        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 160px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += ctrl.proposition.change();
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
    };
}

var MorningThreePropositionChoice = {
    DECLINE: 1,
    AGREE: 2
};
