/**
 * Confrontation section of Varanar, Night Two.
 * @param {NightTwoController} controller The Night Two controller.
 */
function NightTwoCrudeUnfit(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new NightTwoCrudeUnfitContinue(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            You say you are [b]flattered[/b] that the men would even [b]consider[/b] letting a [b]lowly[/b] kobold as yourself kiss their behinds,
                            but you are afraid that you simply [b]can't[/b].
                            You see, you have a [b]rare[/b] and [b]dangerous[/b] disease called [b]tongorrhea[/b],
                            which pretty much means that if your tongue so much as [b]comes close[/b] to their skin, they'll get [b]infected[/b],
                            and their [b]dicks[/b] will [b]shrivel[/b] and [b]fall off[/b] in a couple of months.
                            Not to mention the horrible [b]itching[/b].
                            Their wives won't be too pleased if they go home with a [b]nasty[/b] kobold disease.
                            Surely they can find a non-infected member of your kind to settle this [i]dispute[/i], right?
                        [/p]
                        [p]
                            The group bursts into disarray.
                            "[color=purple]Mangy kobold![/color]"
                            "[color=bred]Jacoby picked this one because he knew he was going to lose the bet![/color]"
                            "[color=green]Hey now, [b]you're[/b] the one with your bare ass close to the diseased vermin's snout![/color]"
                            Realizing his pants are still down, the exposed human in front of you quickly re-dresses, before turning around to face you once more.
                            "[color=bred]Lizard.[/color]" he speaks, drawing your attention.
                            "[color=bred]Thanks for telling us.
                            Wouldn't want to catch any infections from your kind.[/color]"
                            You wave away his thanks, and mention that you're glad things worked out for the better, for [b]both[/b] of you.
                        [/p]
                        [p]
                            Their interest in you vanishing, but their argument still going strong, the drunkards slowly break their encirclement.
                            "[color=brown]Let's go find another one![/color]"
                            "[color=purple]At this hour? Where?[/color]"
                            "[color=dred]To the lizard district![/color]"
                            Like they've completely forgotten you even exist,
                            the group begins to head for the kobold district, leaving you all alone in the middle of the street.
                            Just the way you like it.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = ctrl.crudeUnfit.continued() ? "disabled" : "";
        var isSelected = ctrl.crudeUnfit.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.crudeUnfit.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (ctrl.appease.get() !== NightTwoCrudeAppeaseChoice.UNFIT) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += ctrl.crudeUnfit.change();
        part += buildChoice();
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (ctrl.appease.get() !== NightTwoCrudeAppeaseChoice.UNFIT) {
            return;
        }

        next.registerListeners();

        if (ctrl.crudeUnfit.continued()) {
            return;
        }

        registerNextListener();
    };
}
